﻿using System;
using System.Collections.Generic;
using System.Reflection;
using System.Linq;

namespace GetAllAssemblyMembers {
  class MainClass {
    static void Main(string[] args) {
      foreach (MemberInfo memberInfo in GetAllMembersFunctional()) {
        Console.WriteLine(memberInfo.Name);
      }
    }

    public static List<MemberInfo> GetAllMembers( ) {
      Assembly[] assemblies = AppDomain.CurrentDomain.GetAssemblies( );
      List<Type> types = new List<Type>( );

      foreach (Assembly assembly in assemblies) 
        types.AddRange(assembly.GetTypes( ));

      List<MemberInfo> members = new List<MemberInfo>( );

      foreach (Type type in types)
        members.AddRange(type.GetMembers( ));

      return members;
    }

    public static IEnumerable<MemberInfo> GetAllMembersFunctional() =>
      AppDomain.CurrentDomain.GetAssemblies().SelectMany(
        assembly => assembly.GetTypes().SelectMany(
        type => type.GetMembers()));
    






















    // This implementation uses SelectMany with lambdas to do the work

//    public static IEnumerable<MemberInfo> GetAllMembersFunctional( ) {
//      return AppDomain.CurrentDomain.GetAssemblies( ).SelectMany(
//        assembly => assembly.GetTypes( ).SelectMany(
//            type => type.GetMembers( )));
//    }
//

//    public static IEnumerable<MemberInfo> GetAllMembersFunctional() =>
//    AppDomain.CurrentDomain.GetAssemblies().SelectMany(
//      assembly=>assembly.GetTypes().SelectMany(
//        type=>type.GetMembers()));
//


  }
}
