﻿using System;
using System.Collections.Generic;
using FCSlib;
using System.Linq;

namespace LoggerDemo {
  class MainClass {
    public static void Main(string[] args) {
      var orders = new List<Order> {
        new Order{ Date =new DateTime(2010,6,3), Value = 29.9m},
        new Order{ Date =new DateTime(2010,6,3), Value = 18.6m},
        new Order{ Date =new DateTime(2010,6,4), Value = 119.99m},
        new Order{ Date =new DateTime(2010,7,1), Value = 3.99m},
        new Order{ Date =new DateTime(2010,7,2), Value = 47.62m},
        new Order{ Date =new DateTime(2010,7,3), Value = 99.99m}
      };

      var average =
        orders.
              ToLogger("Starting with a list of {0} orders", 
                       orders.Count()).
        Bind(l => Functional.Filter(
                o => o.Date >= new DateTime(2010, 7, 1), l).ToLogger(
          "Got list with {0} items, filtering...", l.Count())).
        Bind(l => l.Average(o => o.Value).ToLogger(
          "Calculating average for list with remaining {0} items...", l.Count()));

      Console.WriteLine("Result: " + average.Value);

      Console.WriteLine("-------- Log Output:");
      Console.Write(average.LogOutput( ));
    }
  }

  public class Order {
    public DateTime Date { get; set; }
    public decimal Value { get; set; }
  }
}
